%******************************************
% Murder Mystery Case 1 Fact Base
%
%******************************************

%******************************************
% Name the Suspects
%******************************************
suspect(art).
suspect(bert).
suspect(carl).


%******************************************
% Assert Suspects' beliefs or "statements".
%
% Each agent has their own belief space -- a set of
%    statement that they believe (or claim) to be true.
%
% The relationship between an agent and his beliefs
% are represented by the binary relation "belief".
%
%
%******************************************
beliefs(Agent,Beliefs) :-
    setof(B,belief(Agent,B),Beliefs).

belief(art,friend(bert,vic)).
belief(art,hate(carl,vic)).

belief(bert,'-know'(bert,vic)).
belief(bert,absent(bert)).

belief(carl,with(bert,vic)).
belief(carl,with(art,vic)).

belief(system,Fact) :-
     defined_predicate(Fact),!,
     Fact.

belief(system,Fact) :- fail.

willed(vic,bert,money).
hasMoney(vic).